#include <iostream>
#include <cassert>

long long extendedEuclidian(long long a, long long b, long long &pa, long long &pb) {
    long long old_r=a, r=b;
    long long old_s=1, s=0;
    long long old_t=0, t=1;
    while (r > 0) {
        long long q = old_r / r;
        long long tmp;
        tmp = r; r = old_r - q*r; old_r = tmp;
        tmp = s; s = old_s - q*s; old_s = tmp;
        tmp = t; t = old_t - q*t; old_t = tmp;
    }
    pa = old_s;
    pb = old_t;
    return old_r;
}

int main() {
    // long long pa, pb;
    // long long a, b;
    // std::cin >> a >> b;
    // long long gcd = extendedEuclidian(a, b, pa, pb);
    // std::cout << gcd << '=' << pa << '*' << a << '+' << pb << '*' << b << std::endl;

    long long l, m;
    std::cin >> l >> m;
    assert(std::cin.good());
    assert(2 <= l && l <= 1'000'000'000);
    assert(2 <= m && m <= 1'000'000'000);
    //assert(std::min(l, m) <= 5*10'000'000);

    // r = 1 mod l      -> r = k1*l+1 = -k4*l+1
    // r = m - 1 mod m  -> r = k2*m+m-1 = k3*m-1
    // k1*l+1 = k3*m-1  -> k1*l - k3*m = -2 -> k4*l + k3*m = 2
    // using extendedEuclidian alg we can find k4' and k'3 so that k4'*l + k3'*m = gcd(l, m)
    // if gcd(l, m)=1 then we need to multiply k4 by 2 -> 2*k4'*l + 2*k3'*m = 2*1 -> k4 = 2*k4'

    long long k4, k3; // these are actually k4' and k3'
    long long gcd = extendedEuclidian(l, m, k4, k3);
    // std::cout << gcd << '=' << k4 << '*' << l << '+' << k3 << '*' << m << std::endl;

    if(gcd > 2) {
        std::cout << "impossible" << std::endl;
        return 0;
    }

    long long mult = -(2/gcd)*l;


    // in code k4*mult+1 = mult*(-k4'*l) + 1 = -k4*l+1 = r
    // this one answer but not the best
    long long oneAns = k4*mult+1;

    // std::cout << "oneAns=" << oneAns << std::endl;
    long long step = l*m/gcd;
    // std::cout << "step=" << step << std::endl;

    long long k = (oneAns >= 0) ? -oneAns/step : std::abs(oneAns)/step+1;
    // std::cout << "k=" << k << std::endl;

    long long res = oneAns+k*step;

    std::cout << res << std::endl;

    assert(res % l == 1);
    assert(res % m == m-1);
    assert(res >= 0);
    assert(res <= m*l/gcd);

    return 0;
}
